CREATE TABLE GE_SETORES
(
   COD_INSTITUICAO SMALLINT NOT NULL,
   COD_SETOR SMALLINT NOT NULL,
   NOME VARCHAR(30),
   PRIMARY KEY (COD_INSTITUICAO, COD_SETOR)
);

CREATE TABLE SO_TIPOS_SOLICITACAO
(
   COD_TIPO_SOLICITACAO SMALLINT NOT NULL PRIMARY KEY,
   DESCRICAO VARCHAR(70) NOT NULL,
   COD_INSTITUICAO_DESTINO SMALLINT,
   COD_SETOR_DESTINO SMALLINT,
   TIPO_USUARIO TINYINT NOT NULL,
   UNIQUE (DESCRICAO),
   FOREIGN KEY (COD_INSTITUICAO_DESTINO, COD_SETOR_DESTINO) REFERENCES GE_SETORES (COD_INSTITUICAO, COD_SETOR)
);

CREATE TABLE SO_PERMISSOES
(
   COD_PERMISSAO TINYINT NOT NULL PRIMARY KEY
);

CREATE TABLE GE_FUNCIONARIOS
(
   MATRICULA CHAR(8) NOT NULL PRIMARY KEY,
   NOME VARCHAR(50) NOT NULL,
   E_MAIL VARCHAR(35),
   CATEGORIA CHAR(1) NOT NULL CHECK (CATEGORIA IN ('P', 'F')),
   COD_INSTITUICAO SMALLINT,
   COD_SETOR SMALLINT,
   COD_INSTITUICAO_SOLICITACOES SMALLINT,
   COD_SETOR_SOLICITACOES SMALLINT,
   SITUACAO CHAR(1),
   SENHA_2 VARCHAR(40),
   COMPLEMENTO_SENHA VARCHAR(12),
   SENHA_2_MODIFICADA CHAR(1) DEFAULT 'F' NOT NULL,
   IDENTIFICADOR INT,
   VERSAO INT,
   FOREIGN KEY (COD_INSTITUICAO, COD_SETOR) REFERENCES GE_SETORES (COD_INSTITUICAO, COD_SETOR),
   FOREIGN KEY (COD_INSTITUICAO_SOLICITACOES, COD_SETOR_SOLICITACOES) REFERENCES GE_SETORES (COD_INSTITUICAO, COD_SETOR)
);

CREATE TABLE SO_ADMINISTRACOES_FUNCIONARIOS
(
   COD_ADMINISTRADOR CHAR(8) NOT NULL,
   COD_INSTITUICAO SMALLINT NOT NULL,
   COD_SETOR SMALLINT NOT NULL,
   PRIMARY KEY (COD_ADMINISTRADOR, COD_INSTITUICAO, COD_SETOR),
   FOREIGN KEY (COD_ADMINISTRADOR) REFERENCES GE_FUNCIONARIOS (MATRICULA) ON DELETE CASCADE,
   FOREIGN KEY (COD_INSTITUICAO, COD_SETOR) REFERENCES GE_SETORES (COD_INSTITUICAO, COD_SETOR)
);

CREATE TABLE SO_PERMISSOES_FUNCIONARIOS
(
   COD_FUNCIONARIO CHAR(8) NOT NULL,
   COD_INSTITUICAO SMALLINT NOT NULL,
   COD_SETOR SMALLINT NOT NULL,
   COD_PERMISSAO TINYINT NOT NULL,
   PRIMARY KEY (COD_FUNCIONARIO, COD_INSTITUICAO, COD_SETOR, COD_PERMISSAO),
   FOREIGN KEY (COD_FUNCIONARIO) REFERENCES GE_FUNCIONARIOS (MATRICULA) ON DELETE CASCADE,
   FOREIGN KEY (COD_INSTITUICAO, COD_SETOR) REFERENCES GE_SETORES (COD_INSTITUICAO, COD_SETOR),
   FOREIGN KEY (COD_PERMISSAO) REFERENCES SO_PERMISSOES (COD_PERMISSAO) ON DELETE CASCADE
);
