/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.dao.jpa;

import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import br.urca.solicitacoes.Setor;
import br.urca.solicitacoes.dao.ILocalizadorSetoresDAO;

@Stateless
public class LocalizadorSetoresDAOBean implements ILocalizadorSetoresDAO
{
	@PersistenceContext
	private EntityManager fGE;

	@Override
	@SuppressWarnings("unchecked")
	public List<Setor> localizarSetores(short codigoInstituicao)
	{
		return (List<Setor>) fGE.createNamedQuery(
			Setor.SQL_LOCALIZAR_POR_CODIGO_INSTITUICAO).
			setParameter("codigoInstituicao", codigoInstituicao).
			getResultList();
	}
}
