/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.ejb;

import javax.annotation.Resource;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

import br.urca.solicitacoes.Funcionario;
import br.urca.solicitacoes.SolicitacoesException;

@Stateless
public class LocalizadorFuncionarioBean implements ILocalizadorFuncionario
{
	@Resource
	private SessionContext fContexto;
	@PersistenceContext
	private EntityManager fGE;

	@Override
	public Funcionario localizarFuncionarioAutenticado()
	{
		String matricula =
			fContexto.getCallerPrincipal().getName().toUpperCase();
		Funcionario funcionario = fGE.find(Funcionario.class, matricula);
		if (funcionario == null)
		{
			throw new SolicitacoesException(
				"Funcionrio autenticado no encontrado."); 
		}
		return funcionario;
	}

	@Override
	public Funcionario localizarFuncionario(int codigoFuncionario)
	{
		try
		{
			String jpql = FiltroSituacoesAtivasFuncionario.filtrar(
				"SELECT f " +
				"FROM Funcionario f " +
				"WHERE f.codigo = :codigoFuncionario");
			return (Funcionario) fGE.createQuery(jpql).
				setParameter("codigoFuncionario", codigoFuncionario).
				getSingleResult();
		}
		catch (NoResultException ex)
		{
			return null;
		}
	}
}
