/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.ejb;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import br.urca.solicitacoes.DadosFuncionarioAutenticado;
import br.urca.solicitacoes.SolicitacoesException;

//import br.urca.solicitacoes.DadosUsuarioAutenticado;
//import br.urca.solicitacoes.SolicitacoesException;

public final class Utils
{
	private Utils()
	{
	}
	
	/*public static String obterMatriculaUsuarioAutenticado()
	{
		return obterContexto().getCallerPrincipal().getName();
	}*/
	
	public static void validarPermissaoUsuarioParaConsultar(
		DadosFuncionarioAutenticado usuarioAutenticado)
	{
		if (usuarioAutenticado == null)
		{
			throw new NullPointerException("Usurio autenticado nulo.");
		}
		if (!usuarioAutenticado.getPermissoes().
			isConsultarSolicitacoesPessoais() &&
			!usuarioAutenticado.getPermissoes().
			isConsultarTodasSolicitacoes())
		{
			throw new SolicitacoesException(
				"Usurio sem permisso para consultar.");
		}
	}

	/*public static SessionContext obterContexto()
	{
		try
		{
			return (SessionContext) new InitialContext().lookup(
				"java:comp/EJBContext");
		}
		catch (NamingException ex)
		{
			throw new SolicitacoesException(ex);
		}
	}*/
	
	public static DataSource obterFonteDados() throws NamingException
	{
		return (DataSource) new InitialContext().lookup("java:/SolicitacoesDS");
	}
}
