/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

public class DadosAtualizacaoFuncionarioAutenticado
{
	private String fEmail;
	private Setor fSetorPadrao;
	private DadosSenha fDadosSenha;
	
	public DadosAtualizacaoFuncionarioAutenticado(
		String email, Setor setorPadrao)
	{
		if (setorPadrao == null)
		{
			throw new NullPointerException("Setor padro nulo.");
		}
		fEmail = email;
		fSetorPadrao = setorPadrao;
		fDadosSenha = null;
	}

	public DadosAtualizacaoFuncionarioAutenticado(
		String email, Setor setorPadrao, DadosSenha dadosSenha)
	{
		this(email, setorPadrao);
		if (dadosSenha == null)
		{
			throw new NullPointerException("Dados da senha nulo.");
		}
		fDadosSenha = dadosSenha;		
	}
	
	public String getEmail()
	{
		return fEmail;
	}

	public Setor getSetorPadrao()
	{
		return fSetorPadrao;
	}

	public DadosSenha getDadosSenha()
	{
		return fDadosSenha;
	}
}
