/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import java.util.Set;

public final class DadosFuncionarioAutenticado extends InformacoesFuncionario
{
	private final Setor fSetor;
	private String fEmail;
	private boolean fSenhaAlterada;
	private final Set<Setor> fSetores;
	private final boolean fAdministradorGeral;
	private boolean fAdministrador;
	private final PermissoesFuncionario fPermissoes;

	public DadosFuncionarioAutenticado(String matricula, String nome,
		Setor setor, Set<Setor> setores, String email, boolean senhaAlterada,
		boolean administradorGeral, boolean administrador,
		Set<TipoPermissao> permissoes)
	{
		super(matricula, nome);
		if (setores == null)
		{
			throw new NullPointerException("Setores nulo.");
		}
		if (permissoes == null)
		{
			throw new NullPointerException("Permisses nula.");
		}
		fSetor = setor;
		fSetores = setores;
		fEmail = email;
		fSenhaAlterada = senhaAlterada;
		fAdministradorGeral = administradorGeral;
		fAdministrador = administrador;
		fPermissoes = new PermissoesFuncionario(permissoes);
	}

	public Setor getSetor()
	{
		return fSetor;
	}
	
	public String getEmail()
	{
		return fEmail;
	}
	
	public void setEmail(String email)
	{
		fEmail = email;
	}
	
	public boolean isSenhaAlterada()
	{
		return fSenhaAlterada;
	}

	public void setSenhaAlterada(boolean senhaAlterada)
	{
		fSenhaAlterada = senhaAlterada;
	}

	public Set<Setor> getSetores()
	{
		return fSetores;
	}
	
	public boolean isExisteMaisDeUmSetor()
	{
		return fSetores.size() > 1;
	}

	public boolean isAdministradorGeral()
	{
		return fAdministradorGeral;
	}

	public boolean isAdministrador()
	{
		return fAdministrador;
	}

	public void setAdministrador(boolean administrador)
	{
		fAdministrador = administrador;
	}

	public PermissoesFuncionario getPermissoes()
	{
		return fPermissoes;
	}
}
