/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

public final class DadosFuncionarioComPermissoes extends DadosFuncionario
	implements Comparable<DadosFuncionarioComPermissoes>
{
	private final Funcionario fFuncionario;
	private final PermissoesFuncionarioModificaveis fPermissoes;
	
	public DadosFuncionarioComPermissoes(
		Funcionario funcionario, Setor setorAtual)
	{
		super(funcionario.getMatricula(), funcionario.getCodigo(),
			funcionario.getNome(), funcionario.getSetor() == null ?
			null : funcionario.getSetor().getNome());
		fFuncionario = funcionario;
		fPermissoes =
			new PermissoesFuncionarioModificaveis(funcionario, setorAtual);
	}

	public Funcionario getFuncionario()
	{
		return fFuncionario;
	}

	public PermissoesFuncionarioModificaveis getPermissoes()
	{
		return fPermissoes;
	}

	public int compareTo(DadosFuncionarioComPermissoes o)
	{
		// Nome
		int comparacao = getNome().compareTo(o.getNome());
		if (comparacao != 0)
		{
			return comparacao;
		}
		
		// Setor
		if (getSetor() == null)
		{
			comparacao = o.getSetor() == null ? 0 : -1;
		}
		else
		{
			comparacao =
				o.getSetor() == null ? 1 : getSetor().compareTo(o.getSetor());
		}
		return comparacao;
	}
}
