/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.validacao;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import javax.validation.Constraint;
import javax.validation.Payload;

@Documented
@Constraint(validatedBy = {EmailValidator.class})
@Target({ElementType.FIELD, ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
public @interface Email
{
	String message() default "E-mail invlido";
	Class<?>[] groups() default {};
	Class<? extends Payload>[] payload() default {};
}
