/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.componente;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import br.urca.solicitacoes.CodigoSetor;
import br.urca.solicitacoes.Setor;

public class SetorConverter implements Converter
{
	private static final String SEPARADOR_CODIGO = ",";
	private static final String SEPARADOR_NOME   = "|";
	
	public Object getAsObject(
		FacesContext context, UIComponent component, String value)
	{
		int indiceSeparadorNome = value.indexOf(SEPARADOR_NOME);
		
		String codigoStr = value.substring(0, indiceSeparadorNome);
		String[] partes = codigoStr.split(SEPARADOR_CODIGO);
		short codigoInstituicao = Short.parseShort(partes[0]);
		short codigoSetor = Short.parseShort(partes[1]);
		
		Setor setor;
		if (codigoInstituicao ==
			SetorNaoSelecionado.INSTANCIA.getCodigo().getCodigoInstituicao())
		{
			setor = SetorNaoSelecionado.INSTANCIA;
		}
		else
		{
			CodigoSetor codigo =
				new CodigoSetor(codigoInstituicao, codigoSetor);
			String nome = value.substring(indiceSeparadorNome + 1);

			setor = new Setor();
			setor.setCodigo(codigo);
			setor.setNome(nome);
		}
		
		return setor;
	}

	public String getAsString(
		FacesContext context, UIComponent component, Object value)
	{
		Setor setor = (Setor) value;
		String codigo =	setor.getCodigo().getCodigoInstituicao() +
			SEPARADOR_CODIGO + setor.getCodigo().getCodigoSetor();
		return codigo + SEPARADOR_NOME + setor.getNome();
	}
}
