/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.web;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import br.urca.solicitacoes.DadosSenha;
import br.urca.solicitacoes.IGerenciadorFuncionarioAutenticado;
import br.urca.solicitacoes.SenhaException;
import br.urca.solicitacoes.SolicitacoesException;

@ManagedBean
@RequestScoped
public class AlteracaoSenhaProvisoria extends AlteracaoSenha
{
	private String fMensagemErro;
	
	public AlteracaoSenhaProvisoria()
	{
		if (Utils.primeiraExibicao())
		{
			Utils.focalizarComponente("form:senhas:senhaAtual");
		}
	}
	
	public String getMensagemErro()
	{
		return fMensagemErro;
	}
	
	public String alterarSenha()
	{
		try
		{
			IGerenciadorFuncionarioAutenticado atualizadorFuncionario =
				LocalizadorEJB.localizar(
				IGerenciadorFuncionarioAutenticado.class);
			DadosSenha dadosSenha =	new DadosSenha(
				getSenhaAtual(), getNovaSenha(), getConfirmacaoNovaSenha());
			atualizadorFuncionario.atualizarFuncionario(dadosSenha);
			
			FuncionarioAutenticado.getInstancia().setSenhaAlterada(true);
			
			Mensagem.definirMensagem("Senha alterada com sucesso.");
			Mensagem.ocultarBotoes(Mensagem.Botao.SAIR);
			return Navegacao.MENSAGEM;
		}
		catch (Exception ex)
		{
			if (ex.getCause() != null &&
				ex.getCause().getClass() == SenhaException.class)
			{
				fMensagemErro = ex.getCause().getMessage();
				return null;
			}
			throw new SolicitacoesException(ex);
		}
	}
}
