/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.web;

import javax.faces.context.FacesContext;

import br.urca.solicitacoes.DadosFuncionarioAutenticado;
import br.urca.solicitacoes.ILocalizadorFuncionarioAutenticado;
import br.urca.web.jsf.UtilsJSF;

final class FuncionarioAutenticado
{
	private static final String CHAVE = "br.urca.solicitacoes.web.FUNCIONARIO";

	private FuncionarioAutenticado()
	{
	}
	
	static DadosFuncionarioAutenticado getInstancia()
	{
		DadosFuncionarioAutenticado funcionario =
			(DadosFuncionarioAutenticado) UtilsJSF.getSessao().get(CHAVE);
		if (funcionario == null)
		{
			ILocalizadorFuncionarioAutenticado localizadorFuncionario =
				LocalizadorEJB.localizar(
				ILocalizadorFuncionarioAutenticado.class);
			funcionario =
				localizadorFuncionario.localizarFuncionarioAutenticado();
			UtilsJSF.getSessao().put(CHAVE, funcionario);
		}
		return funcionario;
	}
	
	static boolean isAutenticado()
	{
		return FacesContext.getCurrentInstance().getExternalContext().
			getRemoteUser() != null;
	}
	
	static void atualizar()
	{
		UtilsJSF.getSessao().remove(CHAVE);
	}
}
