/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.web;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpSession;

import br.urca.solicitacoes.DadosFuncionarioAutenticado;

@ManagedBean
@SessionScoped
public class Solicitacoes
{
	public static final short VALOR_NAO_SELECIONADO = -1;
	
	public DadosFuncionarioAutenticado getFuncionario()
	{
		return FuncionarioAutenticado.getInstancia();
	}
	
	public void sair(ActionEvent e)
	{
		logout();
		abrirPaginaURCA();		
	}

	private void logout()
	{
		HttpSession sessao = (HttpSession) FacesContext.getCurrentInstance().
			getExternalContext().getSession(false);
		sessao.invalidate();
	}

	private void abrirPaginaURCA()
	{
		try
		{
			ExternalContext contextoExterno =
				FacesContext.getCurrentInstance().getExternalContext();
			contextoExterno.redirect("http://www.urca.br");
		}
		catch (IOException ex)
		{
			throw new FacesException(ex);
		}
	}
}
